import java.awt.*;
import java.awt.Color;
import java.awt.Font;
import java.io.*;

public class Fenetre extends Frame {

	String ret = "\n";
	MenuBar mb;
	Menu m1;
	Menu m2;
	MenuItem it1;
	MenuItem it2;
	MenuItem it3;

	FileWriter fw1;

	int fileNumb = 0;

	TextArea buddy;
	TextArea buddy2;

	Choice filName = new Choice();
	
	Button submit;
	Button dessin;
	Button go;
	Button reload;

	String lineReturn = "";

	Panel forButtons;

	FileReader look;

	Label vide = new Label("");

	Label explain = new Label("");

	CadreDessin first;

	Color myGreen = new Color(213, 213, 255);
	Color myBlue = new Color(138, 138, 255);
	Color myBack = new Color(192, 192, 192);

	BorderLayout bLayout1;
	BorderLayout bLayout2;
	BorderLayout bLayout3;
	GridLayout layout;
	GridLayout layout2;
	GridLayout layout3;
	Image eye = 
		Toolkit.getDefaultToolkit().getImage("ucbl.jpg"); 

	public Fenetre() {

		/***********************************************
		Construit les lments du menu bar
		et deux boites de dialog + un bouton
		***********************************************/

		setSize(640, 480);

		forButtons = new Panel();
		Panel upperButtons = new Panel();

		mb = new MenuBar();
		m1 = new Menu("Fichier");
		m2 = new Menu("Help");
		mb.add(m1);
		mb.add(m2);

		filName.addItem("eec.h");
		filName.addItem("eem.h");


		it1 = new MenuItem("Nouveau");
		it2 = new MenuItem("Quitter");
		it3 = new MenuItem("About");

		m1.add(it1);
		m1.add(it2);
		m2.add(it3);

		buddy = new TextArea(100,35);
		buddy2 = new TextArea(100, 35);
		buddy.setEditable(false);

		submit = new Button(">>");
		dessin = new Button("Modeliser");
		go = new Button("Complete");
		reload = new Button("reload");

		String naze = new String("Hello\n");

		layout = new GridLayout(1, 4);
		layout2 = new GridLayout(1, 3);
		layout3 = new GridLayout(2, 1);
		bLayout1 = new BorderLayout();
		bLayout2 = new BorderLayout();
		bLayout3 = new BorderLayout();

		
		Panel forGoButtons = new Panel();
		forGoButtons.setLayout(layout2);
		upperButtons.setLayout(layout3);
		
		setMenuBar(mb);
		forButtons.setLayout(bLayout3);
		setLayout(bLayout1);

		explain.setBackground(myBack);

		upperButtons.add(submit);
		upperButtons.add(filName);
		
		forGoButtons.add(reload);
		forGoButtons.add(dessin);
		forGoButtons.add(go);

		forButtons.add("North",upperButtons );
		forButtons.add("South", forGoButtons);
		

		add("North", explain);
		add("West", buddy);
		add("East", buddy2);
		add("Center", forButtons);

		

		buddy.setBackground(myGreen);
		buddy2.setBackground(myBlue);
		buddy.append(naze);

	}

	public void paint(Graphics screen) {

		screen.drawImage(eye, 0, 0, this);
		forButtons.getGraphics().drawImage(eye, 0, 0, this);

	}


	/*File source1 = new File("eem.h");
					File source2 = new File("eec.h");
					*/
	
	public void complete(){

		String name ;

		switch (fileNumb) {

			case 0 :name ="eec.h" ;break;
			case 1 :name ="eem.h" ;break;
			default : name =name ="E:\\Vince\\ter\\eec.h" ;break;	
		}

		
		try {
					fw1= new FileWriter(name);
					fw1.write(buddy2.getText());
					fw1.close();
					
				} catch (IOException e) {
				} catch (SecurityException se) {
				}

	reloading();


	}
	
	
	
	
	public  void reloading() {

		String name ;
		buddy2.setText("");
		lineReturn = "";

		
		switch (fileNumb) {

			case 0 :name ="eec.h" ;break;
			case 1 :name ="eem.h" ;break;
			default : name =name ="E:\\Vince\\ter\\eec.h" ;break;	
		}

		
					try {
						look = new FileReader(name);
						BufferedReader buff = new BufferedReader(look);
						boolean eof = false;
						while (!eof) {
							String line = buff.readLine();
							if (line == null)
								eof = true;

							else
								lineReturn += line + ret;
						}
						buff.close();
					} catch (IOException e) {
					} catch (SecurityException se) {
					}
		
				buddy2.setText(lineReturn);

	}

	public boolean action(Event e, Object arg) {

		if (e.target instanceof MenuItem) {
			String Code = (String) arg;
			if (Code.equals("Quitter"))
				System.exit(0);
			if (Code.equals("About")) {
				About about = new About();
				about.show();
			}
		}

		if (e.target instanceof Choice) {
			String Code = (String) arg;
			if (Code.equals("eec.h")){
				fileNumb=0;
				reloading();
			}
				
			if (Code.equals("eem.h")){
				fileNumb=1;
				reloading();
			}
		}

		if (e.target instanceof Button) {
			String Code = (String) arg;
			if (Code.equals(">>"))
				buddy2.insert(buddy.getSelectedText() + ret, buddy2.getCaretPosition());
			if (Code.equals("Complete"))
				complete();			
			if (Code.equals("Modeliser")) {
				first = new CadreDessin();
				first.show();
			}
			if (Code.equals("reload"))
				reloading();
		}
		return true;
	}

	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {
			System.exit(0);
			return (true);
		}
		return super.handleEvent(e);
	}

	public static void main(String args[]) {

		Fenetre test = new Fenetre();
		test.setTitle("DESP-C++ Easy Handler ver 1.0 Bta");
		test.setResizable(true);
		test.show();
		About about = new About();
		about.show();

	}

}