import java.io.*;

class MakeCode {

	/************************************
	 modif du sampleec.h
	 ***********************************/

	/*On f les trucs qui ne sont pas modifis*/
	FileWriter fw1;
	FileWriter fw2;

	String firstPartEeh = "";
	String secondPartEeh = "";
	String firstPartEem = "";
	String secondPartEem = "";
	String sampleeec_h = "";
	String ret = "\n";
	String introEeh = 
		"/////////////////////////////////////////////////////////////////////\n"
			+ " / DESP-C++ (Discrete-Event Simulation Package)\n"
			+ "// Version 1.1, February 1998\n"
			+ "// Jerome Darmont\n// LIMOS, Blaise Pascal University (Clermont-Ferrand II), France\n"
			+ "/////////////////////////////////////////////////////////////////////\n"
			+ "// eventc.h: Event Manager classes definition\n"
			+ "// Variable with simulated systems\n"
			+ "// => Flowshop sample (sample_eventc.h)\n"
			+ "////////////////////////////////////////////////////////////////////////\n"
			+ "// Active resources declaration"; 

	String classEvntManagerEeh = 
		"/////////////////////////////////////////////////////////////////////\n"
			+ "// CLASS EventManager\n"
			+ "/////////////////////////////////////////////////////////////////////\n"
			+ "// Simulation events management\n"
			+ "/////////////////////////////////////////////////////////////////////\n"
			+ "// The Event Manager must know all (active and passive) resources.\n  "
			+ "public execute(serveur tabserveur[],\n"
			+ " resource tabresource[], \n"
			+ "        link tablink[], int nbServeurs,         int nbResources, \n"
			+ " class EventManager {\n  public:\n "
			+ "   // Methods\n"
			+ "    EventManager(Simulation *sim);      // Constructor\n "
			+ "   ~EventManager()   // Destructor\n"
			+ "    void ExecuteEvent(int code, Client *client); // Event execution\n    void Init();                        // Initialization\n    void InitRep();                     // Replication initialization \n    void Stats();                       // Stats computation (end of replication)\n    void DisplayStats();                // Statistics display\n  private:\n    // Attributes\n    Simulation *simul;                  // Pointer toward simulation object\n    // Passive resource;\n"; 

	String classClientEeh = 
		"};\n"
			+ " /////////////////////////////////////////////////////////////////////\n"
			+ "// CLASS Client\n"
			+ "/////////////////////////////////////////////////////////////////////\n"
			+ "// Custom simulation entity\n"
			+ "/////////////////////////////////////////////////////////////////////\n"
			+ "class Client {\n"
			+ "  public:\n"
			+ "           // Add here (in public) additional attributes\n"
			+ "           Client *next;\n"
			+ "           Client *previous;\n"
			+ "};\n"
			+ "/////////////////////////////////////////////////////////////////////\n"
			+ "// CLASS Machine\n"
			+ "/////////////////////////////////////////////////////////////////////\n"; 

	String sampleeem_h = "";
	String introEem = 
		"/////////////////////////////////////////////////////////////////////\n"
			+ "// DESP-C++ (Discrete-Event Simulation Package)\n"
			+ "// Version 1.1, February 1998\n"
			+ "// Jerome Darmont\n"
			+ "// LIMOS, Blaise Pascal University (Clermont-Ferrand II), France\n"
			+ "/////////////////////////////////////////////////////////////////////\n"
			+ "// eventc.h: Event Manager methods definition\n"
			+ "// Variable with simulated systems\n"
			+ "// => Flowshop sample (sample_eventc.h)\n"
			+ "/////////////////////////////////////////////////////////////////////\n"
			+ "#include stdlib.h \n"
			+ "#include string.h\n"
			+ "/////////////////////////////////////////////////////////////////////\n"
			+ "// CLASS EventManager\n"
			+ "/////////////////////////////////////////////////////////////////////\n"
			+ "// CLASS EventManager: Constructor\n"
			+ "EventManager::EventManager(Simulation *sim) {\n"
			+ "  simul=sim;\n"; 
	String deleteEem = 
		"// CLASS EventManager: Destructor"
			+ ret
			+ "EventManager::~EventManager() {"
			+ ret; 

	String initEem = 
		"// CLASS EventManager: Stats init for each resource\n"
			+ "void EventManager::Init() {\n  // Passive resources\n"; 

	String initRepEem = 
		"// CLASS EventManager: Replications initialization \n "
			+ "void EventManager::InitRep() {\n"
			+ "  // Scheduler\n  simul->Sched()->Purge();\n  // Passive resources\n"; 
	String statsEem = 
		"// CLASS EventManager: Stats computation for each resource \n"
			+ "void EventManager::Stats() {\n"; 

	String displayStats = 
		"// CLASS EventManager: Stats display for each resource"
			+ "void EventManager::DisplayStats() {\n"; 

	String executeEvent = 
		" // CLASS EventManager: Events execution \n"
			+ " void EventManager::ExecuteEvent(int code, Client *client) { \n"
			+ " switch(code) {\n"
			+ "case 0:  machine1->Event10(client);break;"
			+ ret; 

	String defaultEem = 
		"default: printf(\"Error: unknown event #%d at time %f\",code,simul->Tnow());\n}\n"
			+ ret
			+ ret; 

	String constructors = "";

	/* On attak les premires modifs. ici la dclaration des Machines. modifies apres la fonction CreateStringServeur*/

	String MachinesEeh = "";
	String PtrMachinesEeh = "";

	String instanceEem = "";

	/*On s'occupe des resources NActive*/

	String PtrResourcesEeh = "";

	/* On va s'oocuper des liens qui on t faits aussi */

	String MachinesuivEeh = "";
	String ResourcePtrEeh = "";
	String ResourceRbEeh = "";
	String addFunctEeh = "";
	String strSortieEeh = "";
	String temp = "";

	MakeCode(
		AResource tabserveur[], 
		PResource tabresource[], 
		Link tablink[], 
		int nbServeurs, 
		int nbResources, 
		int nbLinks) {
		createStringServeur(tabserveur, nbServeurs);
		createStringPtrResources(tabresource, nbResources);
		firstPartEeh = 
			introEeh
				+ ret
				+ MachinesEeh
				+ ret
				+ classEvntManagerEeh
				+ ret
				+ PtrResourcesEeh
				+ ret
				+ PtrMachinesEeh
				+ ret
				+ classClientEeh; 

		for (int i = 0; i < 100; i++) {
			secondPartEeh += createStringClassMachine(tabserveur, tablink, i);
			executeEvent += createStringEventExecution(tabserveur, tablink, i);
			temp += createStringConstructors(tabserveur, tablink, i);
		}

		firstPartEem = introEem + instanceEem + "}" + ret + deleteEem + "}";
		secondPartEem = 
			initEem
				+ "}"
				+ ret
				+ initRepEem
				+ "}"
				+ ret
				+ statsEem
				+ "}"
				+ ret
				+ displayStats
				+ "}"
				+ ret
				+ executeEvent
				+ defaultEem
				+ temp; 

		sampleeec_h = firstPartEeh + secondPartEeh + ret + strSortieEeh + ret;
		sampleeem_h = firstPartEem + secondPartEem;

		try {
			File source1 = new File("e:\\vince\\ter\\eem.h");
			File source2 = new File("e:\\vince\\ter\\eec.h");
			fw1 = new FileWriter("e:\\vince\\ter\\eem.h");
			fw2 = new FileWriter("e:\\vince\\ter\\eec.h");
			fw1.write(sampleeem_h);
			fw2.write(sampleeec_h);
			fw1.close();
			fw2.close();
		} catch (IOException e) {
		} catch (SecurityException se) {
		}

	}

	public void createStringPtrResources(
		PResource tabresource[], 
		int nbResources) {
		int cptnbResources = 0;
		int i = 0;
		// a checker : on considre ici que toutes les rersources sont consec. c faux, a repoir
		while (cptnbResources != nbResources) {
			if (tabresource[i].name != "libre") {
				PtrResourcesEeh += "Resource *robot" + Integer.toString(i + 1) + ret;
				deleteEem += "delete robot" + Integer.toString(i + 1) + ";\n" + ret;
				initEem += "robot" + Integer.toString(i + 1) + "->ResetStats();\n";
				initRepEem += "robot"
					+ Integer.toString(i + 1)
					+ "->ResetCounters();\n  robot"
					+ Integer.toString(i + 1)
					+ "->PurgeQueue();\n"; 
				statsEem += "robot" + Integer.toString(i + 1) + "->Stats();\n";
				displayStats += "robot" + Integer.toString(i + 1) + "->DisplayStats();\n";
				instanceEem += "// Passive resources instantiation\n"
					+ "robot"
					+ Integer.toString(i + 1)
					+ "=new Resource(\"Robot"
					+ Integer.toString(i + 1)
					+ "\",1,simul);"
					+ ret; 
				cptnbResources++;

			}
			i++;
		}

	}

	public String createStringConstructors(
		AResource s[], 
		Link tablink[], 
		int indice) {

		String resource = "Resource(n, cap, sim) {\n";
		String classM = "";
		String mSuiv = "";
		String MachinesuivEem = "";
		String temp = "";
		String machines = "";
		int numClass = indice + 1;
		int i = 0;

		while (i < 100) {
			if (s[indice].associate[i] > 0) {

				if (s[indice].Sortie == true) {

					temp += "Machine"
						+ Integer.toString(numClass)
						+ "::Machine"
						+ Integer.toString(numClass)
						+ "(char n[STRS], int cap, Simulation *sim, Resource *rob): Resource(n, cap, sim) {\n"
						+ "robot=rob; \n  production=0; }\n // CLASS Machine"
						+ Integer.toString(numClass)
						+ ": Event #"
						+ Integer.toString(numClass)
						+ "0 - Arrival on M"
						+ Integer.toString(numClass)
						+ "\n"
						+ "void Machine"
						+ Integer.toString(numClass)
						+ "::Event"
						+ Integer.toString(numClass)
						+ "0(Client *client) {\n"
						+ "//  printf(\"Release robot - Waiting for M2 at time %f\",Sim()->Tnow());\n"
						+ "robot->V();\n  this->P("
						+ Integer.toString(numClass)
						+ "1,client,1);\n }\n"
						+ "// CLASS Machine"
						+ Integer.toString(numClass)
						+ ": Event #"
						+ Integer.toString(numClass)
						+ "1 - Begin product transformation\n"
						+ "void Machine"
						+ Integer.toString(numClass)
						+ "::Event"
						+ Integer.toString(numClass)
						+ "1(Client *client) {\n"
						+ "//  printf(\"Begin transformation on M"
						+ Integer.toString(numClass)
						+ " at time %f\",Sim()->Tnow());\n"
						+ "Sim()->Sched()->Schedule("
						+ Integer.toString(numClass)
						+ "2,Sim()->Tnow()+Exp(12),client);\n }\n"
						+ "// CLASS Machine"
						+ Integer.toString(numClass)
						+ ": Event #"
						+ Integer.toString(numClass)
						+ "2 - End product transformation\n"
						+ "void Machine"
						+ Integer.toString(numClass)
						+ "::Event"
						+ Integer.toString(numClass)
						+ "2(Client *client) {\n"
						+ "//  printf(\"End transformation on M"
						+ Integer.toString(numClass)
						+ " at time %f - Waiting for robot\",Sim()->Tnow());\n"
						+ ret
						+ ret
						+ "\nrobot->P("
						+ Integer.toString(numClass)
						+ "3,client,1);\n }\n"
						+ "// CLASS Machine2: Event #"
						+ Integer.toString(numClass)
						+ "3 - Transfer out of M"
						+ Integer.toString(numClass)
						+ "\n"
						+ "void Machine"
						+ Integer.toString(numClass)
						+ "::Event"
						+ Integer.toString(numClass)
						+ "3(Client *client) {\n"
						+ "//  printf(\"Release M"
						+ Integer.toString(numClass)
						+ " - Transfer out of M"
						+ Integer.toString(numClass)
						+ " at time %f\",Sim()->Tnow());\n"
						+ "this->V(); \n   Sim()->Sched()->Schedule("
						+ Integer.toString(numClass)
						+ "4,Sim()->Tnow()+Uni(4,6),client);\n}\n"
						+ "// CLASS Machine"
						+ Integer.toString(numClass)
						+ ": Event #"
						+ Integer.toString(numClass)
						+ "4 - Transfer out of system"
						+ "void Machine"
						+ Integer.toString(numClass)
						+ "::Event"
						+ Integer.toString(numClass)
						+ "4(Client *client) {\n"
						+ "//  printf(\"Release robot at time %f\",Sim()->Tnow());\n  robot->V();\n"
						+ " production++;\n  Sim()->KillClient(client);\n //  printf(\"Production=%d\n\",production);"
						+ ret
						+ "}"; 

				} else
					temp += "// CLASS Machine"
						+ Integer.toString(numClass)
						+ ": Event #"
						+ Integer.toString(numClass)
						+ "0 - Arrival on M"
						+ Integer.toString(numClass)
						+ "\n"
						+ "void Machine"
						+ Integer.toString(numClass)
						+ "::Event"
						+ Integer.toString(numClass)
						+ "0(Client *client) {\n"
						+ "//  printf(\"Waiting for M"
						+ Integer.toString(numClass)
						+ " at time %f\",Sim()->Tnow());\n"
						+ "this->P("
						+ Integer.toString(numClass)
						+ "1,client,1);\n }\n"
						+ "\n// CLASS Machine"
						+ Integer.toString(numClass)
						+ ": Event #"
						+ Integer.toString(numClass)
						+ "1 - Begin product generation\n"
						+ "void Machine"
						+ Integer.toString(numClass)
						+ "::Event"
						+ Integer.toString(numClass)
						+ "1(Client *client) {\n"
						+ "//  printf(\"Begin production on M"
						+ Integer.toString(numClass)
						+ " at time %f\",Sim()->Tnow());\n"
						+ "Sim()->Sched()->Schedule("
						+ Integer.toString(numClass)
						+ "2,Sim()->Tnow()+Exp(10),client);\n}\n"
						+ "\n// CLASS Machine1: Event #"
						+ Integer.toString(numClass)
						+ "2 - Product out\n"
						+ "void Machine"
						+ Integer.toString(numClass)
						+ "::Event"
						+ Integer.toString(numClass)
						+ "2(Client *client) {\n"
						+ "//  printf(\"End production on M"
						+ Integer.toString(numClass)
						+ " at time %f - Waiting for robot\",Sim()->Tnow());"
						+ "robot->P("
						+ Integer.toString(numClass)
						+ "3,client,1);\n"
						+ "\n// CLASS Machine1: Event #"
						+ Integer.toString(numClass)
						+ "3 - Transfer toward M"
						+ Integer.toString(numClass + 1)
						+ "\n"
						+ "void Machine"
						+ Integer.toString(numClass)
						+ "::Event"
						+ Integer.toString(numClass)
						+ "3(Client *client) {\n"
						+ "Client *newclient;\n"
						+ "//  printf(\"Release M"
						+ Integer.toString(numClass)
						+ " - Transfer M"
						+ Integer.toString(numClass)
						+ "-M"
						+ Integer.toString(numClass + 1)
						+ " at time %f\",Sim()->Tnow());\n"
						+ "this->V();\n  newclient=Sim()->NewClient();\n"
						+ "Sim()->Sched()->Schedule("
						+ Integer.toString(numClass)
						+ "0,Sim()->Tnow(),newclient);\n"
						+ "Sim()->Sched()->Schedule(20,Sim()->Tnow()+Uni(4,6),client);}"; 

			}
			i++;
		}
		String intro = 
			"/////////////////////////////////////////////////////////////////////\n"
				+ "// CLASS Machine"
				+ Integer.toString(numClass)
				+ "\n /////////////////////////////////////////////////////////////////////"
				+ "// CLASS Machine"
				+ Integer.toString(numClass)
				+ ": Constructor"; 
		String machineInit = 
			"Machine"
				+ Integer.toString(numClass)
				+ "::Machine"
				+ Integer.toString(numClass)
				+ "(char n[STRS], int cap, Simulation *sim"; 

		i = 0;
		while (i < 100) {
			if (s[indice].associate[i] > 0) {
				if ((tablink[i].destServeur != indice)
					&& (tablink[i].isDest == "serveur")
					&& (tablink[i].isOrigin == "serveur")) {

					MachinesuivEem += "Machine"
						+ Integer.toString(tablink[i].destServeur + 1)
						+ " * suiv"
						+ Integer.toString(tablink[i].destServeur + 1); 

					mSuiv += "m"
						+ Integer.toString(tablink[i].destServeur + 1)
						+ "= suiv"
						+ Integer.toString(tablink[i].destServeur + 1)
						+ ";"
						+ ret; 

				}

			}
			i++;
		}

		if (MachinesuivEem == "")
			return temp;
		else {
			temp += machineInit + MachinesuivEem + ") :" + resource + classM + "}\n";

			return temp;
		}

	}

	public String createStringEventExecution(
		AResource s[], 
		Link tablink[], 
		int indice) {

		int numClass = indice + 1;
		int cpt = 1;
		int test = 0;
		String temp = "";

		temp += "case "
			+ Integer.toString(numClass)
			+ "0: machine"
			+ Integer.toString(numClass)
			+ "->Event"
			+ Integer.toString(numClass)
			+ "0(client);break;\n"
			+ "case "
			+ Integer.toString(numClass)
			+ "1: machine"
			+ Integer.toString(numClass)
			+ "->Event"
			+ Integer.toString(numClass)
			+ "1(client);break;\n"
			+ "case "
			+ Integer.toString(numClass)
			+ "2: machine"
			+ Integer.toString(numClass)
			+ "->Event"
			+ Integer.toString(numClass)
			+ "2(client);break;\n"
			+ "case "
			+ Integer.toString(numClass)
			+ "3: machine"
			+ Integer.toString(numClass)
			+ "->Event"
			+ Integer.toString(numClass)
			+ "3(client);break;\n"; 

		if (s[indice].Sortie != false)
			temp += "case "
				+ Integer.toString(numClass)
				+ "4: machine"
				+ Integer.toString(numClass)
				+ "->Event"
				+ Integer.toString(numClass)
				+ "4(client);break;\n"; 

		for (int i = 0; i < 100; i++) {
			if (s[indice].associate[i] != -1)
				test = 1;
		}

		if (test == 1)
			return (temp);
		return ("");
	}

	public String createStringClassMachine(
		AResource s[], 
		Link tablink[], 
		int indice) {

		int count = 0;
		String endInstanceEem = "";
		MachinesuivEeh = "";
		ResourcePtrEeh = "";
		ResourceRbEeh = "";
		addFunctEeh = "";

		int numClass = indice + 1;
		int cpt = 1;

		String introEeh = 
			"\nclass Machine"
				+ Integer.toString(numClass)
				+ ": public Resource {\n  public:\n    // Constructor\n    Machine"
				+ Integer.toString(numClass)
				+ "(char n[STRS], int cap, Simulation *sim"; 
		String declEventEeh = 
			"// Events\n  void Event"
				+ Integer.toString(numClass)
				+ "0(Client *client);       // Arrival on M1\n    void Event"
				+ Integer.toString(numClass)
				+ "1(Client *client);       // Begin product generation\n    void Event"
				+ Integer.toString(numClass)
				+ "2(Client *client);       // Product out\n    void Event"
				+ Integer.toString(numClass)
				+ "3(Client *client);       // Transfert \n"; 

		String privEeh = "private:                              // Pointers\n";

		String MachinesuivEehExit = "";
		String ResourcePtrEehExit = "";
		String instanceEemExit = "";

		if ((s[indice].name != "libre") && (s[indice].name != "rien")) {
			instanceEem += "machine"
				+ Integer.toString(numClass)
				+ "=new Machine"
				+ Integer.toString(numClass)
				+ "(\"Machine #"
				+ Integer.toString(numClass)
				+ "\",1,simul"; 

		}

		// a corriger pour le robot qui n'est pas tks prsent ;
		int i = 0;
		while (i < 100) {
			if (s[indice].associate[i] > 0) {

				if (s[indice].Sortie == true) {

					for (int l = 0; l < 100; l++) {
						if ((tablink[l].destServeur == tablink[i].destServeur)
							&& (tablink[l].isOrigin == "resource")
							&& (l != i)) {

							MachinesuivEehExit += ",Resource *rob"
								+ Integer.toString(tablink[l].originServeur + 1); 

							ResourcePtrEehExit += "Resource *robot"
								+ Integer.toString(tablink[l].originServeur + 1)
								+ ";"
								+ ret; 
						}
					}

					strSortieEeh = 
						"/////////////////////////////////////////////////////////////////////\n// CLASS Machine"
							+ Integer.toString(numClass)
							+ "/////////////////////////////////////////////////////////////////////\n class Machine"
							+ Integer.toString(numClass)
							+ ": public Resource {\n  public:\n    // Constructor\n    Machine"
							+ Integer.toString(numClass)
							+ "(char n[STRS], int cap, Simulation *sim"
							+ MachinesuivEehExit
							+ ");\n    // Events\n    void Event"
							+ Integer.toString(numClass)
							+ "0(Client *client);       // Arrival on M2\n    void Event"
							+ Integer.toString(numClass)
							+ "1(Client *client);       // Begin transformation\n    void Event"
							+ Integer.toString(numClass)
							+ "2(Client *client);       // End transformation\n    void Event"
							+ Integer.toString(numClass)
							+ "3(Client *client);       // Transfer out of M2\n    void Event"
							+ Integer.toString(numClass)
							+ "4(Client *client);       // Transfer out of system\n  private:                              // Pointers\n    "
							+ ResourcePtrEehExit
							+ "              // Robot (PR)\n    int production;                     // Counter\n};\n"; 

					for (int l = 0; l < 100; l++) {
						if ((tablink[l].destServeur == tablink[i].destServeur)
							&& (tablink[l].isOrigin == "resource")
							&& (l != i)) {

							instanceEemExit += " ,robot" + Integer.toString(tablink[l].originServeur + 1);

						}
							
					}
					

					instanceEem += instanceEemExit;
				}

				if ((count < 1)&&(instanceEemExit!="")) {

						instanceEem += ");" + ret;
						count++;
					}

			
					

				if (tablink[i].isOrigin == "serveur") {

					if ((tablink[i].isDest == "serveur") && (tablink[i].destServeur != indice)) {
						MachinesuivEeh += ",Machine"
							+ Integer.toString(tablink[i].destServeur + 1)
							+ " * suiv"
							+ Integer.toString(tablink[i].destServeur + 1); 

						ResourcePtrEeh += "Machine"
							+ Integer.toString(tablink[i].destServeur + 1)
							+ " * m"
							+ Integer.toString(tablink[i].destServeur + 1)
							+ ";"
							+ ret; 

						instanceEem += ", machine" + Integer.toString(tablink[i].destServeur + 1);

						for (int l = 0; l < 100; l++) {
							if ((tablink[l].destServeur == tablink[i].destServeur)
								&& (tablink[l].isOrigin == "resource")&&(l!=i)) {

								MachinesuivEeh += ",Resource *rob"
									+ Integer.toString(tablink[l].originServeur + 1); 

								ResourcePtrEeh += "Resource robot*"
									+ Integer.toString(tablink[l].originServeur + 1); 

								instanceEem+=" ,robot"+Integer.toString(tablink[l].originServeur + 1);

							}
						}

					}
					if (tablink[i].isDest == "resource") {
						MachinesuivEeh += ",Resource* rob"
							+ Integer.toString(tablink[i].destServeur + 1); 

						ResourcePtrEeh += "Resource *robot"
							+ Integer.toString(tablink[i].destServeur + 1)
							+ ret; 

						for (int l = 0; l < 100; l++) {
							if ((tablink[l].originServeur == tablink[i].destServeur)
								&& (tablink[l].isOrigin == "resource")&&(l!=i)) {
								MachinesuivEeh += ",Machine"
									+ Integer.toString(tablink[l].destServeur + 1)
									+ " * suiv"
									+ Integer.toString(tablink[l].destServeur + 1); 

								ResourcePtrEeh += "Machine"
									+ Integer.toString(tablink[l].destServeur + 1)
									+ " * m"
									+ Integer.toString(tablink[l].destServeur + 1)
									+ ";"
									+ ret; 

								//instanceEem += " ,robot" + Integer.toString(tablink[i].destServeur + 1);
							}

						}

					}

					if (cpt > 1) {
						addFunctEeh += "void Event"
							+ Integer.toString(numClass)
							+ Integer.toString(cpt + 2)
							+ "(Client *client);"; 
					}
					cpt++;

				} else {
					if ((tablink[i].destServeur != indice)
						&& ((tablink[i].isDest == "resource") || (tablink[i].isOrigin == "resource"))) {
						ResourceRbEeh = 
							"Resource * Robot" + Integer.toString(tablink[i].destServeur + 1) + ";" + ret; 
					}

				}

			}

			i++;

		}

		if (MachinesuivEeh == "")
			return (MachinesuivEeh);
		else {
			instanceEem += ");" + ret;

			return (
				introEeh
					+ MachinesuivEeh
					+ ");"
					+ ret
					+ declEventEeh
					+ addFunctEeh
					+ ret
					+ privEeh
					+ ResourcePtrEeh
					+ ResourceRbEeh
					+ ret
					+ "};"); 

		}

	}
	public void createStringServeur(AResource tabserveur[], int nbServeurs) {
		int i = 0;
		while (i != nbServeurs) {
			if (tabserveur[i].name != "libre") {
				MachinesEeh += "class Machine" + Integer.toString(i + 1) + " ;" + ret;
				PtrMachinesEeh += "Machine"
					+ Integer.toString(i + 1)
					+ " * machine"
					+ Integer.toString(i + 1)
					+ " ;"
					+ ret; 
				deleteEem += "delete machine" + Integer.toString(i + 1) + ";" + ret;
				initEem += "machine" + Integer.toString(i + 1) + "->ResetStats();\n";
				initRepEem += "machine"
					+ Integer.toString(i + 1)
					+ "->ResetCounters();\n  machine"
					+ Integer.toString(i + 1)
					+ "->PurgeQueue();\n"; 
				statsEem += "machine" + Integer.toString(i + 1) + "->Stats();\n";
				displayStats += "machine" + Integer.toString(i + 1) + "->DisplayStats();\n";
				i++;
			}
		}
	}
}