import java.awt.*;
import java.awt.Color;
import java.awt.Font;

class CadreDessin extends Frame {

	String links = "Link ";
	String serveurs = "Machine ";
	String resources = "Resource ";
	String ret = "\n";

	int fond = 0;

	MenuBar mb;
	Menu m1;
	MenuItem it1;
	MenuItem it2;
	MenuItem it3;
	MenuItem it4;
	MenuItem it5;
	MenuItem it6;

	Image eye1;

	CheckboxGroup radio;
	Checkbox p1;
	Checkbox p2;
	Checkbox p3;
	Checkbox p4;
	Checkbox p5;
	Checkbox p6;

	Color mauve = new Color(196, 196, 255);
	Color mauve2 = new Color(0, 128, 128);
	Color couleur3 = new Color(192, 192, 192);

	Panel pOption;
	Panel pRadio;
	//Label title;
	Label explain = new Label("");
	Label vide = new Label("");
	Label vide2 = new Label("");
	Label vide3 = new Label("");
	Label vide4 = new Label("");
	Label vide5 = new Label("");

	GridLayout gRadioButton = new GridLayout(13, 1);
	BorderLayout layout;
	BorderLayout layout2;

	Button reset;

	AResource tabserveur[] = new AResource[100];
	Link tablink[] = new Link[100];
	PResource tabresource[] = new PResource[100];

	int nbLinks = 0;
	int nbServeurs = 0;
	int nbResources = 0;

	int lastTouched = -1;

	int check1 = 0;
	int check2 = 0;

	public CadreDessin() {

		mb = new MenuBar();
		m1 = new Menu("BackGround");
		mb.add(m1);

		it1 = new MenuItem("Lumire");
		it2 = new MenuItem("Hiver");
		it3 = new MenuItem("Nounours");
		it4 = new MenuItem("NBC fans");
		it5 = new MenuItem("Sunlight");
		it6 = new MenuItem("Mechanical");

		m1.add(it1);
		m1.add(it2);
		m1.add(it3);
		m1.add(it4);
		m1.add(it5);
		m1.add(it6);

		Label choice = new Label("Choix possibles");
		Label validation = new Label("Validation");
		setSize(640, 480);
		layout = new BorderLayout();
		layout2 = new BorderLayout();
		radio = new CheckboxGroup();
		pRadio = new Panel();
		pOption = new Panel();
		reset = new Button("Reset");
		Button go = new Button("Complete");

		p1 = new Checkbox("Ressource Active", radio, true);
		p2 = new Checkbox("Liaison", radio, false);
		p3 = new Checkbox("Supprimer RA", radio, false);
		p4 = new Checkbox("Ressource Passive", radio, false);
		p5 = new Checkbox("Marquer la Sortie", radio, false);
		p6 = new Checkbox("Supprimer PR", radio, false);
	
		setLayout(layout);
		pRadio.setLayout(gRadioButton);



		pRadio.add(choice);
		pRadio.add(p1);
		pRadio.add(p3);
		pRadio.add(p4);
		pRadio.add(p6);
		pRadio.add(p2);
		pRadio.add(p5);
		pRadio.add(vide);
		pRadio.add(vide2);
		pRadio.add(vide3);
		pRadio.add(vide4);

		pRadio.add(reset);
		pRadio.add(go);

		pOption.setLayout(layout2);
		pOption.add("Center", pRadio);
		pOption.setBackground(mauve2);

		add("West", pOption);


		setMenuBar(mb);

		init();

	}

	public int min(int a, int b) {
		if (a < b)
			return a;
		else
			return b;
	}

	public void init() {
		for (int i = 0; i < 100; i++) {
			tabserveur[i] = new AResource("rien");

			tablink[i] = new Link("rien");
			tabresource[i] = new PResource("rien");
			repaint();

		}

	}

	/***********************************************************
	Lorsk un serveur au nom de "rien" est cr, c'est k'il na jamais
	t touch. lorskil est libre, il a t cr mais supprim par la
	suite. Idem pour les links
	***********************************************************/

	public int addServeur(int x, int y) {
		int i = 0;
		while ((tabserveur[i].name != "rien") && (tabserveur[i].name != "libre")) {
			i++;
		}
		nbServeurs++;
		tabserveur[i] = new AResource(i, x, y);
		return i;
	}

	public void supressServeur(int i) {

		int j = 0;
		while (j < 100) {
			if (tabserveur[i].associate[j] != -1)
				supressLink(j);
			j++;
		}

		tabserveur[i] = new AResource("libre");
		nbServeurs--;
		repaint();

	}

	public int getServeurNumber(int x, int y) {
		int ok = -1;
		int i = 0;
		while ((tabserveur[i].name != "rien") && (ok == -1)) {
			if ((x <= (tabserveur[i].coordx + 40))
				&& (x >= tabserveur[i].coordx)
				&& (y >= tabserveur[i].coordy)
				&& (y <= (tabserveur[i].coordy + 40)))
				ok = i;
			i++;
		}
		return ok;
	}

	public int addResource(int x, int y) {
		int i = 0;
		while ((tabresource[i].name != "rien") && (tabresource[i].name != "libre")) {
			i++;
		}
		nbResources++;

		tabresource[i] = new PResource(i, x, y);
		return i;
	}

	public void supressResources(int i) {

		int j = 0;
		while (j < 100) {

			if (tabresource[i].associate[j] != -1)
				supressLink(j);
			j++;
		}

		tabresource[i] = new PResource("libre");
		nbResources--;
		repaint();

	}

	public int getResourceNumber(int x, int y) {
		int ok = -1;
		int i = 0;
		while ((tabresource[i].name != "rien") && (ok == -1)) {
			if ((x <= (tabresource[i].coordx + 50))
				&& (x >= tabresource[i].coordx)
				&& (y >= tabresource[i].coordy)
				&& (y <= (tabresource[i].coordy + 20)))
				ok = i;
			i++;
		}
		return ok;
	}

	public boolean testUniqueLink(int num1, int num2, int c) {

		if ((tabserveur[num1].associate[c] == 1)
			&& (tabserveur[num2].associate[c] == 1))
			return false;
		else
			return true;
	}

	public void supressLink(int i) {

		tabserveur[tablink[i].destServeur].associate[i] = -1;
		tabserveur[tablink[i].originServeur].associate[i] = -1;
		tablink[i] = new Link("libre");
		nbLinks--;
		repaint();

	}

	public void drawLink(Graphics screen) {


		int i = 0;
		while (tablink[i].name != "rien") {
			if (tablink[i].name != "libre")
				screen.drawLine(
					tablink[i].departLinex, 
					tablink[i].departLiney, 
					tablink[i].arriveeLinex, 
					tablink[i].arriveeLiney); 

			i++;
		}
	}

	public void drawServeur(Graphics screen) {
		int i = 0;
		while (tabserveur[i].name != "rien") {
			if (tabserveur[i].name != "libre")
				screen.fillRect(tabserveur[i].coordx, tabserveur[i].coordy, 40, 40);
			screen.drawString(
				serveurs + Integer.toString(i + 1), 
				tabserveur[i].coordx - 5, 
				tabserveur[i].coordy - 10); 
			if (tabserveur[i].Sortie == true) {
				screen.drawRect(tabserveur[i].coordx + 20, tabserveur[i].coordy + 10, 60, 20);
				screen.drawString(
					"Sortie", 
					tabserveur[i].coordx + 90, 
					tabserveur[i].coordy + 25); 
			}
			i++;
		}
	}

	public void drawResource(Graphics screen) {
		int i = 0;
		while (tabresource[i].name != "rien") {
			if (tabresource[i].name != "libre")
				screen.fillOval(tabresource[i].coordx, tabresource[i].coordy, 50, 20);
			screen.drawString(
				resources + Integer.toString(i + 1), 
				tabresource[i].coordx - 5, 
				tabresource[i].coordy - 10); 

			i++;
		}

	}

	public void paint(Graphics screen) {

		switch (fond) {

			case 0 :
				{
					eye1 = 
						Toolkit.getDefaultToolkit().getImage(
							"AdvancedLighting.jpg"); 
					break;
				}
			case 1 :
				{
					eye1 = 
						Toolkit.getDefaultToolkit().getImage(
							"Antarctica2.JPG"); 
					break;
				}
			case 2 :
				{
					eye1 = 
						Toolkit.getDefaultToolkit().getImage("bear_rgb.JPG"); 
					break;
				}
			case 3 :
				{
					eye1 = 
						Toolkit.getDefaultToolkit().getImage(
							"Fresnel_Water2.JPG"); 
					break;
				}
			case 4 :
				{
					eye1 = 
						Toolkit.getDefaultToolkit().getImage(
							"weekback01.JPG"); 
					break;
				}
			case 5 :
				{
					eye1 = 
						Toolkit.getDefaultToolkit().getImage(
							"afilmgris_rgb.JPG"); 
					break;
				}
			default :
				{
					eye1 = 
						Toolkit.getDefaultToolkit().getImage(
							"afilmgris_rgb.JPG"); 
					break;
				}
		}

		screen.drawImage(eye1, 0, 0, this);
		//setBackground(mauve);
		screen.setColor(Color.blue);
		drawLink(screen);
		drawServeur(screen);
		drawResource(screen);

	}

	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) {

			hide();
			return (true);

			/**************************************************
			Evenement d'une fenetre qui se ferme sa tue sa race
			***************************************************/
		}

		if (e.id == Event.MOUSE_DOWN) {

			int numtemp = getServeurNumber(e.x, e.y);
			int numtemp2 = getResourceNumber(e.x, e.y);

			if ((p2.getState() == true) && (nbServeurs >= 2)) {
				/*******************************************************************************
				   p2 == cration d'une liaison
							1) regarde si le bouton est coch.
							2) si le nombre de serveur vaut au moins deux
							3) et que le point de touche de la souris est bien un serveur ( le rectangle qui le reprsente )
				
				   Action : cration 
							1) d'une ligne a l'ecran ( aprs la mthode paint )
							2) d'une indentification de liaison
							3) d'une liaison entre deux serveurs
							
				**********************************************************************************/

				if (numtemp > -1) {
					lastTouched = addLink(tabserveur[numtemp]);
					// renvoie le rang du premier Link libre
					tablink[lastTouched].isOrigin = "serveur";
	
					check1 = 1;

				} else {
					if (numtemp2 > -1) {

						
						
						
						lastTouched = addLink(tabresource[numtemp2]);
						tablink[lastTouched].isOrigin = "resource"; // passif
						check1 = 1;

					}
				}



			}

			if ((p1.getState() == true) && (nbServeurs < 100)) {

				/************************************************************************************
					p1 == cration d'un serveur
						 1) regarde si le bouton est coch.
						 2) si le nombre de serveur est inf a 5
				
					   Action : cration
							1) d'un rectangle a l'cran
				***********************************************************************************/

				addServeur(e.x, e.y);
				repaint();

			}

			if ((p3.getState() == true) && (getServeurNumber(e.x, e.y) != -1)) {
				/***************************************************
				va gicler un serveur : il lui faut limner aussi
				tous ses links ... 
				*************************************************/
				supressServeur(getServeurNumber(e.x, e.y));

			}

			if ((p6.getState() == true) && (getResourceNumber(e.x, e.y) != -1)) {
				/***************************************************
				va gicler une PR : il lui faut limner aussi
				tous ses links ... 
				*************************************************/
				supressResources(getResourceNumber(e.x, e.y));

			}

			if ((p4.getState() == true) && (nbResources < 5)) {

				addResource(e.x, e.y);
				repaint();

			}

			if ((p5.getState() == true) && (nbServeurs >= 1)) {
				if (numtemp > -1) {
					tabserveur[numtemp].Sortie = true;
					repaint();
				}
			}

		}

		if (e.id == Event.MOUSE_UP) {

			int numtemp = getServeurNumber(e.x, e.y);
			int numtemp2 = getResourceNumber(e.x, e.y);

			if ((p2.getState() == true) && (nbServeurs >= 2)) {

				if (numtemp > -1) {
					check2 = 1;
					
						

					tablink[lastTouched].arriveeLinex = tabserveur[numtemp].coordx + 10;
					tablink[lastTouched].arriveeLiney = tabserveur[numtemp].coordy + 10;
					tablink[lastTouched].destServeur = tabserveur[numtemp].numero;
					tablink[lastTouched].isDest = "serveur";
					
					if ((check1 == check2) && (check2 == 1)) {
						repaint();
						nbLinks++;
						
						if (tablink[lastTouched].isOrigin == "serveur")
						addAssociate(
							tabserveur[tablink[lastTouched].originServeur], 
							tabserveur[tablink[lastTouched].destServeur], 
							lastTouched);
						if (tablink[lastTouched].isOrigin == "resource")
						addAssociate(
							tabresource[tablink[lastTouched].originServeur], 
							tabserveur[tablink[lastTouched].destServeur], 
							lastTouched);

					}

				} else {
					if (numtemp2 > -1) {
						check2 = 1;

						
						tablink[lastTouched].arriveeLinex = tabresource[numtemp2].coordx + 25;
						tablink[lastTouched].arriveeLiney = tabresource[numtemp2].coordy + 10;
						tablink[lastTouched].destServeur = tabresource[numtemp2].numero;
						tablink[lastTouched].isDest = "resource";
						
						if ((check1 == check2) && (check2 == 1)) {
							repaint();
							nbLinks++;
							if (tablink[lastTouched].isOrigin == "serveur")
							addAssociate(
								tabserveur[tablink[lastTouched].originServeur], 
								tabresource[tablink[lastTouched].destServeur], 
								lastTouched); 
						}
					} else {
						tablink[lastTouched] = new Link("libre");
					}
				}

				check1 = 0;
				check2 = 0;
				lastTouched = -1;
			}
		}
		return super.handleEvent(e);
	}

	public boolean action(Event e, Object arg) {

		if (e.target instanceof MenuItem) {
			String Code = (String) arg;
			if (Code.equals("Lumire")) {
				fond = 0;
				repaint();
			}
			if (Code.equals("Hiver")) {
				fond = 1;
				repaint();
			}
			if (Code.equals("Nounours")) {
				fond = 2;
				repaint();
			}
			if (Code.equals("NBC fans")) {
				fond = 4;
				repaint();
			}
			if (Code.equals("Sunlight")) {
				fond = 5;
				repaint();
			}
			if (Code.equals("Mechanical")) {
				fond = 6;
				repaint();
			}
			if (Code.equals("About")) {
				About about = new About();
				about.show();
			}
		}

		if (e.target instanceof Button) {
			String Code = (String) arg;
			if (Code.equals("Reset")) {
				init();
				nbLinks = 0;
				nbServeurs = 0;
				nbResources = 0;
				lastTouched = -1;
				check1 = 0;
				check2 = 0;
				repaint();
			}

			if (Code.equals("Complete")) {
				new MakeCode(
					tabserveur, 
					tabresource, 
					tablink, 
					nbServeurs, 
					nbResources, 
					nbLinks); 
			}
		}

		return true;
	}

	public static void main(String args[]) {

		CadreDessin essay = new CadreDessin();
		essay.setTitle("Modlisation du Problme");
		essay.setResizable(true);
		essay.show();
	}

	public void addAssociate(AResource a, AResource b, int number) {

		if (a.associate[number] != 1) {
			a.associate[number] = 1;
			a.nbAssociates++;
		}

		if (b.associate[number] != 1) {
			b.associate[number] = 1;
			b.nbAssociates++;
		}

	}
	public void addAssociate(AResource a, PResource b, int number) {

		if (a.associate[number] != 1) {
			a.associate[number] = 1;
			a.nbAssociates++;
		}

		if (b.associate[number] != 1) {
			b.associate[number] = 1;
			b.nbAssociates++;
		}

	}

	public void addAssociate(PResource a, AResource b, int number) {

		if (a.associate[number] == -1) {
			a.associate[number] = 1;
			a.nbAssociates++;
		}

		if (b.associate[number] == -1) {
			b.associate[number] = 1;
			b.nbAssociates++;
		}

	}

	public int addLink(AResource origin) {
		int i = 0;
		while ((tablink[i].name != "rien") && (tablink[i].name != "libre")) {
			i++;
		}

		tablink[i] = new Link(origin);
		return i;

	}
	public int addLink(PResource origin) {
		int i = 0;
		while ((tablink[i].name != "rien") && (tablink[i].name != "libre")) {
			i++;
		}

		tablink[i] = new Link(origin);
		return i;

	}
}